diff --git a/libcfs/autoconf/lustre-libcfs.m4 b/libcfs/autoconf/lustre-libcfs.m4
index 0e9779f..b4c622b 100644
--- a/libcfs/autoconf/lustre-libcfs.m4
+++ b/libcfs/autoconf/lustre-libcfs.m4
@@ -128,6 +128,7 @@ LB_LINUX_TRY_COMPILE([
 	__u64 *data2 = NULL;
 
 	data1 = data2;
+	*data1 = 1;
 ],[
 	AC_MSG_RESULT([yes])
         AC_DEFINE(HAVE_KERN__U64_LONG_LONG, 1,
@@ -487,6 +488,7 @@ AC_DEFUN([LIBCFS_FUNC_DUMP_TRACE],
 	],[
 		struct stacktrace_ops ops;
 		ops.address = print_addr;
+		ops.address(NULL, 0, 0);
 	],[
 		AC_MSG_RESULT(yes)
 		AC_DEFINE(HAVE_TRACE_ADDRESS_RELIABLE, 1,
@@ -702,6 +704,72 @@ LB_LINUX_TRY_COMPILE([
 ])
 ])
 
+# 2.6.38 ctl_name field is removed from ctl_table
+AC_DEFUN([LC_CTL_NAME],
+[AC_MSG_CHECKING([struct ctl_table has ctl_name field])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/sysctl.h>
+],[
+        struct ctl_table tmp = { .ctl_name = 0 };
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_CTL_NAME, 1,
+                  [struct ctl_table has ctl_name field])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+# 2.6.38 ctl_name field is removed from ctl_table
+AC_DEFUN([LC_CTL_NAME],
+[AC_MSG_CHECKING([struct ctl_table has ctl_name field])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/sysctl.h>
+],[
+        struct ctl_table tmp = { .ctl_name = 0 };
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_CTL_NAME, 1,
+                  [struct ctl_table has ctl_name field])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+# 2.6.38 fsync removes dentry argument
+AC_DEFUN([LC_FSYNC_TWO_ARGS],
+[AC_MSG_CHECKING([fsync has two arguments])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/fs.h>
+],[
+        struct file_operations fops;
+	fops.fsync(NULL, 1);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_FSYNC_TWO_ARGS, 1,
+                  [fsync has two arguments])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+# 2.6.38 tcp_sendpage first argument type is struct sock
+AC_DEFUN([LC_SOCK_TCP_SENDPAGE],
+[AC_MSG_CHECKING([tcp_sendpage first argument type is struct sock])
+LB_LINUX_TRY_COMPILE([
+        #include <net/tcp.h>
+],[
+	struct sock *sk;
+	tcp_sendpage(sk, NULL, 0, 0, 0);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_SOCK_TCP_SENDPAGE, 1,
+                  [tcp_sendpage first argument type is struct sock])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
 #
 # LIBCFS_PROG_LINUX
 #
@@ -754,6 +822,10 @@ LIBCFS_STACKTRACE_OPS_HAVE_WALK_STACK
 LC_SHRINKER_WANT_SHRINK_PTR
 # 2.6.34
 LIBCFS_ADD_WAIT_QUEUE_EXCLUSIVE
+# 2.6.38
+LC_CTL_NAME
+LC_FSYNC_TWO_ARGS
+LC_SOCK_TCP_SENDPAGE
 ])
 
 #
@@ -852,6 +924,7 @@ AC_COMPILE_IFELSE([
 		__u64 *data2 = NULL;
 
 		data1 = data2;
+		*data1 = 1;
 		return 0;
 	}
 ],[
diff --git a/libcfs/include/libcfs/libcfs_fail.h b/libcfs/include/libcfs/libcfs_fail.h
index b9dcd6b..add0208 100644
--- a/libcfs/include/libcfs/libcfs_fail.h
+++ b/libcfs/include/libcfs/libcfs_fail.h
@@ -127,14 +127,14 @@ static inline int cfs_fail_timeout_set(__u32 id, __u32 value, int ms, int set)
  * the first and continues. */
 static inline void cfs_race(__u32 id)
 {
-        int rc;
-
         if (CFS_FAIL_PRECHECK(id)) {
                 if (unlikely(__cfs_fail_check_set(id, 0, CFS_FAIL_LOC_NOSET))) {
+                        int rc;
+
                         cfs_race_state = 0;
                         CERROR("cfs_race id %x sleeping\n", id);
                         cfs_wait_event_interruptible(cfs_race_waitq, cfs_race_state != 0, rc);
-                        CERROR("cfs_fail_race id %x awake\n", id);
+                        CERROR("cfs_fail_race id %x awake: %d\n", id, rc);
                 } else {
                         CERROR("cfs_fail_race id %x waking\n", id);
                         cfs_race_state = 1;
diff --git a/libcfs/include/libcfs/linux/kp30.h b/libcfs/include/libcfs/linux/kp30.h
index 122a506..59aa9ba 100644
--- a/libcfs/include/libcfs/linux/kp30.h
+++ b/libcfs/include/libcfs/linux/kp30.h
@@ -39,7 +39,12 @@
 
 
 #ifndef AUTOCONF_INCLUDED
-# include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/kernel.h>
 #include <linux/mm.h>
diff --git a/libcfs/include/libcfs/linux/linux-fs.h b/libcfs/include/libcfs/linux/linux-fs.h
index 9d42a6c..5510553 100644
--- a/libcfs/include/libcfs/linux/linux-fs.h
+++ b/libcfs/include/libcfs/linux/linux-fs.h
@@ -69,7 +69,11 @@ cfs_file_t *cfs_filp_open (const char *name, int flags, int mode, int *err);
 #define cfs_filp_close(f)                   filp_close(f, NULL)
 #define cfs_filp_read(fp, buf, size, pos)   (fp)->f_op->read((fp), (buf), (size), pos)
 #define cfs_filp_write(fp, buf, size, pos)  (fp)->f_op->write((fp), (buf), (size), pos)
-#define cfs_filp_fsync(fp)                  (fp)->f_op->fsync((fp), (fp)->f_dentry, 1)
+#ifdef HAVE_FSYNC_TWO_ARGS
+#  define cfs_filp_fsync(fp)                  (fp)->f_op->fsync((fp), 1)
+#else
+#  define cfs_filp_fsync(fp)                  (fp)->f_op->fsync((fp), (fp)->f_dentry, 1)
+#endif
 
 #define cfs_get_file(f)                     get_file(f)
 #define cfs_get_fd(x)                       fget(x)
diff --git a/libcfs/include/libcfs/linux/linux-lock.h b/libcfs/include/libcfs/linux/linux-lock.h
index e3a8e66..af268ce 100644
--- a/libcfs/include/libcfs/linux/linux-lock.h
+++ b/libcfs/include/libcfs/linux/linux-lock.h
@@ -208,11 +208,17 @@ typedef struct completion cfs_completion_t;
 typedef struct mutex cfs_mutex_t;
 
 #define CFS_DEFINE_MUTEX(name)             DEFINE_MUTEX(name)
-#define CFS_DECLARE_MUTEX(name)            DECLARE_MUTEX(name)
 
 #define cfs_mutex_init(x)                   mutex_init(x)
+#ifdef DEFINE_SEMAPHORE
+#define CFS_DECLARE_MUTEX(name)             DEFINE_SEMAPHORE(name)
+#define cfs_init_mutex(x)                   sema_init(x, 1)
+#define cfs_init_mutex_locked(x)            sema_init(x, 0)
+#else
+#define CFS_DECLARE_MUTEX(name)             DECLARE_MUTEX(name)
 #define cfs_init_mutex(x)                   init_MUTEX(x)
 #define cfs_init_mutex_locked(x)            init_MUTEX_LOCKED(x)
+#endif
 #define cfs_mutex_up(x)                     up(x)
 #define cfs_mutex_down(x)                   down(x)
 #define cfs_up(x)                           up(x)
diff --git a/libcfs/include/libcfs/linux/linux-prim.h b/libcfs/include/libcfs/linux/linux-prim.h
index 19fbca1..06442d8 100644
--- a/libcfs/include/libcfs/linux/linux-prim.h
+++ b/libcfs/include/libcfs/linux/linux-prim.h
@@ -50,7 +50,12 @@
 #endif
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/init.h>
diff --git a/libcfs/include/libcfs/linux/linux-time.h b/libcfs/include/libcfs/linux/linux-time.h
index 43c1f34..efb5845 100644
--- a/libcfs/include/libcfs/linux/linux-time.h
+++ b/libcfs/include/libcfs/linux/linux-time.h
@@ -99,7 +99,12 @@
 #endif
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/libcfs/libcfs/linux/linux-debug.c b/libcfs/libcfs/linux/linux-debug.c
index 7b2d3a9..f70a7c0 100644
--- a/libcfs/libcfs/linux/linux-debug.c
+++ b/libcfs/libcfs/linux/linux-debug.c
@@ -43,7 +43,12 @@
 #endif
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kmod.h>
diff --git a/libcfs/libcfs/linux/linux-module.c b/libcfs/libcfs/linux/linux-module.c
index d290172..b4a10cf 100644
--- a/libcfs/libcfs/linux/linux-module.c
+++ b/libcfs/libcfs/linux/linux-module.c
@@ -131,9 +131,14 @@ libcfs_psdev_release(struct inode * inode, struct file * file)
 	return rc;
 }
 
+#ifdef HAVE_COMPAT_IOCTL
+static long
+libcfs_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+#else
 static int
-libcfs_ioctl(struct inode *inode, struct file *file,
-	     unsigned int cmd, unsigned long arg)
+libcfs_ioctl(struct inode *inode, struct file *file, unsigned int cmd,
+             unsigned long arg)
+#endif
 {
 	struct cfs_psdev_file	 pfile;
 	int    rc = 0;
@@ -172,7 +177,11 @@ libcfs_ioctl(struct inode *inode, struct file *file,
 }
 
 static struct file_operations libcfs_fops = {
+#ifdef HAVE_COMPAT_IOCTL
+	compat_ioctl:   libcfs_ioctl,
+#else
 	ioctl:   libcfs_ioctl,
+#endif
 	open:    libcfs_psdev_open,
 	release: libcfs_psdev_release
 };
diff --git a/libcfs/libcfs/linux/linux-prim.c b/libcfs/libcfs/linux/linux-prim.c
index 1b59e0b..11c19de 100644
--- a/libcfs/libcfs/linux/linux-prim.c
+++ b/libcfs/libcfs/linux/linux-prim.c
@@ -36,7 +36,12 @@
 
 #define DEBUG_SUBSYSTEM S_LNET
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/libcfs/libcfs/linux/linux-proc.c b/libcfs/libcfs/linux/linux-proc.c
index 9777ffb..6800684 100644
--- a/libcfs/libcfs/linux/linux-proc.c
+++ b/libcfs/libcfs/linux/linux-proc.c
@@ -45,7 +45,12 @@
 #endif
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
@@ -362,7 +367,9 @@ static cfs_sysctl_table_t lnet_table[] = {
          * to go via /proc for portability.
          */
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_DEBUG,
+#endif
                 .procname = "debug",
                 .data     = &libcfs_debug,
                 .maxlen   = sizeof(int),
@@ -370,7 +377,9 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_dobitmasks,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_SUBSYSTEM_DEBUG,
+#endif
                 .procname = "subsystem_debug",
                 .data     = &libcfs_subsystem_debug,
                 .maxlen   = sizeof(int),
@@ -378,7 +387,9 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_dobitmasks,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_PRINTK,
+#endif
                 .procname = "printk",
                 .data     = &libcfs_printk,
                 .maxlen   = sizeof(int),
@@ -386,7 +397,9 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_dobitmasks,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_CONSOLE_RATELIMIT,
+#endif
                 .procname = "console_ratelimit",
                 .data     = &libcfs_console_ratelimit,
                 .maxlen   = sizeof(int),
@@ -394,21 +407,27 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_dointvec
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_CONSOLE_MAX_DELAY_CS,
+#endif
                 .procname = "console_max_delay_centisecs",
                 .maxlen   = sizeof(int),
                 .mode     = 0644,
                 .proc_handler = &proc_console_max_delay_cs
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_CONSOLE_MIN_DELAY_CS,
+#endif
                 .procname = "console_min_delay_centisecs",
                 .maxlen   = sizeof(int),
                 .mode     = 0644,
                 .proc_handler = &proc_console_min_delay_cs
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_CONSOLE_BACKOFF,
+#endif
                 .procname = "console_backoff",
                 .maxlen   = sizeof(int),
                 .mode     = 0644,
@@ -416,7 +435,9 @@ static cfs_sysctl_table_t lnet_table[] = {
         },
 
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_DEBUG_PATH,
+#endif
                 .procname = "debug_path",
                 .data     = libcfs_debug_file_path_arr,
                 .maxlen   = sizeof(libcfs_debug_file_path_arr),
@@ -425,7 +446,9 @@ static cfs_sysctl_table_t lnet_table[] = {
         },
 
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_UPCALL,
+#endif
                 .procname = "upcall",
                 .data     = lnet_upcall,
                 .maxlen   = sizeof(lnet_upcall),
@@ -433,7 +456,9 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_dostring,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_DEBUG_LOG_UPCALL,
+#endif
                 .procname = "debug_log_upcall",
                 .data     = lnet_debug_log_upcall,
                 .maxlen   = sizeof(lnet_debug_log_upcall),
@@ -441,54 +466,68 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_dostring,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_MEMUSED,
+                .strategy = &sysctl_intvec,
+#endif
                 .procname = "lnet_memused",
                 .data     = (int *)&libcfs_kmemory.counter,
                 .maxlen   = sizeof(int),
                 .mode     = 0444,
                 .proc_handler = &proc_dointvec,
-                .strategy = &sysctl_intvec,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_CATASTROPHE,
+                .strategy = &sysctl_intvec,
+#endif
                 .procname = "catastrophe",
                 .data     = &libcfs_catastrophe,
                 .maxlen   = sizeof(int),
                 .mode     = 0444,
                 .proc_handler = &proc_dointvec,
-                .strategy = &sysctl_intvec,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_PANIC_ON_LBUG,
+                .strategy = &sysctl_intvec,
+#endif
                 .procname = "panic_on_lbug",
                 .data     = &libcfs_panic_on_lbug,
                 .maxlen   = sizeof(int),
                 .mode     = 0644,
                 .proc_handler = &proc_dointvec,
-                .strategy = &sysctl_intvec,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_DUMP_KERNEL,
+#endif
                 .procname = "dump_kernel",
                 .maxlen   = 256,
                 .mode     = 0200,
                 .proc_handler = &proc_dump_kernel,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_DAEMON_FILE,
+#endif
                 .procname = "daemon_file",
                 .mode     = 0644,
                 .maxlen   = 256,
                 .proc_handler = &proc_daemon_file,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_DEBUG_MB,
+#endif
                 .procname = "debug_mb",
                 .mode     = 0644,
                 .proc_handler = &proc_debug_mb,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_WATCHDOG_RATELIMIT,
+#endif
                 .procname = "watchdog_ratelimit",
                 .data     = &libcfs_watchdog_ratelimit,
                 .maxlen   = sizeof(int),
@@ -497,7 +536,10 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .extra1   = &min_watchdog_ratelimit,
                 .extra2   = &max_watchdog_ratelimit,
         },
-        {       .ctl_name = PSDEV_LNET_FORCE_LBUG,
+        {
+#ifdef HAVE_CTL_NAME
+                .ctl_name = PSDEV_LNET_FORCE_LBUG,
+#endif
                 .procname = "force_lbug",
                 .data     = NULL,
                 .maxlen   = 0,
@@ -505,7 +547,9 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &libcfs_force_lbug
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_FAIL_LOC,
+#endif
                 .procname = "fail_loc",
                 .data     = &cfs_fail_loc,
                 .maxlen   = sizeof(cfs_fail_loc),
@@ -513,7 +557,9 @@ static cfs_sysctl_table_t lnet_table[] = {
                 .proc_handler = &proc_fail_loc
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_FAIL_VAL,
+#endif
                 .procname = "fail_val",
                 .data     = &cfs_fail_val,
                 .maxlen   = sizeof(int),
@@ -526,7 +572,9 @@ static cfs_sysctl_table_t lnet_table[] = {
 #ifdef CONFIG_SYSCTL
 static cfs_sysctl_table_t top_table[] = {
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = CTL_LNET,
+#endif
                 .procname = "lnet",
                 .mode     = 0555,
                 .data     = NULL,
@@ -534,7 +582,9 @@ static cfs_sysctl_table_t top_table[] = {
                 .child    = lnet_table,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = 0
+#endif
         }
 };
 
diff --git a/libcfs/libcfs/linux/linux-tcpip.c b/libcfs/libcfs/linux/linux-tcpip.c
index 9d673f0..17895e2 100644
--- a/libcfs/libcfs/linux/linux-tcpip.c
+++ b/libcfs/libcfs/linux/linux-tcpip.c
@@ -84,8 +84,12 @@ libcfs_sock_ioctl(int cmd, unsigned long arg)
 #endif
              {
                 lock_kernel();
+#ifdef HAVE_COMPAT_IOCTL
+                rc =sock_filp->f_op->compat_ioctl(sock_filp, cmd, arg);
+#else
                 rc =sock_filp->f_op->ioctl(sock_filp->f_dentry->d_inode,
                                            sock_filp, cmd, arg);
+#endif
                 unlock_kernel();
              }
         set_fs(oldmm);
@@ -597,6 +601,13 @@ int sock_create_lite(int family, int type, int protocol, struct socket **res)
 }
 #endif
 
+#ifndef HAVE_SK_SLEEP_HELPER
+static inline wait_queue_head_t *sk_sleep(struct sock *sk)
+{
+        return sk->sk_sleep;
+}
+#endif
+
 int
 libcfs_sock_accept (struct socket **newsockp, struct socket *sock)
 {
@@ -617,7 +628,7 @@ libcfs_sock_accept (struct socket **newsockp, struct socket *sock)
         newsock->ops = sock->ops;
 
         set_current_state(TASK_INTERRUPTIBLE);
-        add_wait_queue(sock->sk->sk_sleep, &wait);
+        add_wait_queue(sk_sleep(sock->sk), &wait);
 
         rc = sock->ops->accept(sock, newsock, O_NONBLOCK);
         if (rc == -EAGAIN) {
@@ -626,7 +637,7 @@ libcfs_sock_accept (struct socket **newsockp, struct socket *sock)
                 rc = sock->ops->accept(sock, newsock, O_NONBLOCK);
         }
 
-        remove_wait_queue(sock->sk->sk_sleep, &wait);
+        remove_wait_queue(sk_sleep(sock->sk), &wait);
         set_current_state(TASK_RUNNING);
 
         if (rc != 0)
@@ -645,7 +656,7 @@ EXPORT_SYMBOL(libcfs_sock_accept);
 void
 libcfs_sock_abort_accept (struct socket *sock)
 {
-        wake_up_all(sock->sk->sk_sleep);
+        wake_up_all(sk_sleep(sock->sk));
 }
 
 EXPORT_SYMBOL(libcfs_sock_abort_accept);
diff --git a/libcfs/libcfs/nidstrings.c b/libcfs/libcfs/nidstrings.c
index d5b03ed..9269423 100644
--- a/libcfs/libcfs/nidstrings.c
+++ b/libcfs/libcfs/nidstrings.c
@@ -78,15 +78,17 @@ void libcfs_init_nidstrings (void)
 # define NIDSTR_LOCK(f)   cfs_spin_lock_irqsave(&libcfs_nidstring_lock, f)
 # define NIDSTR_UNLOCK(f) cfs_spin_unlock_irqrestore(&libcfs_nidstring_lock, f)
 #else
-# define NIDSTR_LOCK(f)   (f=0)                 /* avoid unused var warnings */
-# define NIDSTR_UNLOCK(f) (f=0)
+# define NIDSTR_LOCK(f)   do {} while (0)
+# define NIDSTR_UNLOCK(f) do {} while (0)
 #endif
 
 static char *
 libcfs_next_nidstring (void)
 {
         char          *str;
+#ifdef __KERNEL__
         unsigned long  flags;
+#endif
 
         NIDSTR_LOCK(flags);
 
diff --git a/lnet/klnds/mxlnd/mxlnd.h b/lnet/klnds/mxlnd/mxlnd.h
index 236c0e4..b18b1ee 100644
--- a/lnet/klnds/mxlnd/mxlnd.h
+++ b/lnet/klnds/mxlnd/mxlnd.h
@@ -45,7 +45,12 @@
 #define EXPORT_SYMTAB
 #endif
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>       /* module */
 #include <linux/kernel.h>       /* module */
diff --git a/lnet/klnds/o2iblnd/o2iblnd.h b/lnet/klnds/o2iblnd/o2iblnd.h
index 4538b11..b3891b1 100644
--- a/lnet/klnds/o2iblnd/o2iblnd.h
+++ b/lnet/klnds/o2iblnd/o2iblnd.h
@@ -42,7 +42,12 @@
 # define EXPORT_SYMTAB
 #endif
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/lnet/klnds/ptllnd/ptllnd.h b/lnet/klnds/ptllnd/ptllnd.h
index 6ee5bd7..d187aac 100755
--- a/lnet/klnds/ptllnd/ptllnd.h
+++ b/lnet/klnds/ptllnd/ptllnd.h
@@ -42,7 +42,12 @@
 # define EXPORT_SYMTAB
 #endif
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/lnet/klnds/qswlnd/qswlnd.h b/lnet/klnds/qswlnd/qswlnd.h
index d4a6964..c3d104d 100644
--- a/lnet/klnds/qswlnd/qswlnd.h
+++ b/lnet/klnds/qswlnd/qswlnd.h
@@ -47,7 +47,12 @@
 #include <qsnet/kernel.h>
 #undef printf                                   /* nasty QSW #define */
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 
diff --git a/lnet/klnds/ralnd/ralnd.h b/lnet/klnds/ralnd/ralnd.h
index ce52c00..32934c6 100644
--- a/lnet/klnds/ralnd/ralnd.h
+++ b/lnet/klnds/ralnd/ralnd.h
@@ -42,7 +42,12 @@
 # define EXPORT_SYMTAB
 #endif
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/lnet/klnds/socklnd/socklnd_lib-linux.c b/lnet/klnds/socklnd/socklnd_lib-linux.c
index 6907ab2..30c9669 100644
--- a/lnet/klnds/socklnd/socklnd_lib-linux.c
+++ b/lnet/klnds/socklnd/socklnd_lib-linux.c
@@ -601,7 +601,13 @@ ksocknal_lib_send_kiov (ksock_conn_t *conn, ksock_tx_t *tx)
                         rc = sk->sk_prot->sendpage(sk, page,
                                                    offset, fragsize, msgflg);
                 } else {
-                        rc = tcp_sendpage(sock, page, offset, fragsize, msgflg);
+                        rc = tcp_sendpage(
+#ifdef HAVE_SOCK_TCP_SENDPAGE
+                                          sk,
+#else
+                                          sock,
+#endif
+                                          page, offset, fragsize, msgflg);
                 }
         } else {
 #if SOCKNAL_SINGLE_FRAG_TX || !SOCKNAL_RISK_KMAP_DEADLOCK
diff --git a/lnet/klnds/socklnd/socklnd_lib-linux.h b/lnet/klnds/socklnd/socklnd_lib-linux.h
index 494ce8e..7b3e8a4 100644
--- a/lnet/klnds/socklnd/socklnd_lib-linux.h
+++ b/lnet/klnds/socklnd/socklnd_lib-linux.h
@@ -43,7 +43,12 @@
 #define __LINUX_SOCKNAL_LIB_H__
 
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/module.h>
 #include <linux/kernel.h>
diff --git a/lnet/lnet/router.c b/lnet/lnet/router.c
index 7fe9a0d..f438657 100644
--- a/lnet/lnet/router.c
+++ b/lnet/lnet/router.c
@@ -1127,13 +1127,10 @@ lnet_router_checker(void *arg)
         int                rc;
         lnet_peer_t       *rtr;
         cfs_list_t        *entry;
-        lnet_process_id_t  rtr_id;
 
         cfs_daemonize("router_checker");
         cfs_block_allsigs();
 
-        rtr_id.pid = LUSTRE_SRV_LNET_PID;
-
         LASSERT (the_lnet.ln_rc_state == LNET_RC_STATE_RUNNING);
 
         while (the_lnet.ln_rc_state == LNET_RC_STATE_RUNNING) {
diff --git a/lnet/lnet/router_proc.c b/lnet/lnet/router_proc.c
index fde0e0a..2fc07a1 100644
--- a/lnet/lnet/router_proc.c
+++ b/lnet/lnet/router_proc.c
@@ -691,37 +691,49 @@ static cfs_sysctl_table_t lnet_table[] = {
          * to go via /proc for portability.
          */
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_STATS,
+#endif
                 .procname = "stats",
                 .mode     = 0644,
                 .proc_handler = &proc_lnet_stats,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_ROUTES,
+#endif
                 .procname = "routes",
                 .mode     = 0444,
                 .proc_handler = &proc_lnet_routes,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_ROUTERS,
+#endif
                 .procname = "routers",
                 .mode     = 0444,
                 .proc_handler = &proc_lnet_routers,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_PEERS,
+#endif
                 .procname = "peers",
                 .mode     = 0444,
                 .proc_handler = &proc_lnet_peers,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_PEERS,
+#endif
                 .procname = "buffers",
                 .mode     = 0444,
                 .proc_handler = &proc_lnet_buffers,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = PSDEV_LNET_NIS,
+#endif
                 .procname = "nis",
                 .mode     = 0444,
                 .proc_handler = &proc_lnet_nis,
@@ -731,7 +743,9 @@ static cfs_sysctl_table_t lnet_table[] = {
 
 static cfs_sysctl_table_t top_table[] = {
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = CTL_LNET,
+#endif
                 .procname = "lnet",
                 .mode     = 0555,
                 .data     = NULL,
@@ -739,7 +753,9 @@ static cfs_sysctl_table_t top_table[] = {
                 .child    = lnet_table,
         },
         {
+#ifdef HAVE_CTL_NAME
                 .ctl_name = 0
+#endif
         }
 };
 
diff --git a/lnet/selftest/conrpc.c b/lnet/selftest/conrpc.c
index 94074ae..bd9aa92 100644
--- a/lnet/selftest/conrpc.c
+++ b/lnet/selftest/conrpc.c
@@ -427,7 +427,6 @@ void
 lstcon_rpc_trans_stat(lstcon_rpc_trans_t *trans, lstcon_trans_stat_t *stat)
 {
         lstcon_rpc_t      *crpc;
-        srpc_client_rpc_t *rpc;
         srpc_msg_t        *rep;
         int                error;
 
@@ -439,8 +438,6 @@ lstcon_rpc_trans_stat(lstcon_rpc_trans_t *trans, lstcon_trans_stat_t *stat)
                                       lstcon_rpc_t, crp_link) {
                 lstcon_rpc_stat_total(stat, 1);
 
-                rpc = crpc->crp_rpc;
-
                 LASSERT (crpc->crp_stamp != 0);
 
                 error = lstcon_rpc_get_reply(crpc, &rep);
@@ -478,7 +475,6 @@ lstcon_rpc_trans_interpreter(lstcon_rpc_trans_t *trans,
         cfs_list_t           *next;
         lstcon_rpc_ent_t     *ent;
         srpc_generic_reply_t *rep;
-        srpc_client_rpc_t    *rpc;
         lstcon_rpc_t         *crpc;
         srpc_msg_t           *msg;
         lstcon_node_t        *nd;
@@ -503,8 +499,6 @@ lstcon_rpc_trans_interpreter(lstcon_rpc_trans_t *trans,
 
                 ent = cfs_list_entry(next, lstcon_rpc_ent_t, rpe_link);
 
-                rpc = crpc->crp_rpc;
-
                 LASSERT (crpc->crp_stamp != 0);
 
                 error = lstcon_rpc_get_reply(crpc, &msg);
diff --git a/lnet/selftest/timer.c b/lnet/selftest/timer.c
index b4e5d52..094c95d 100644
--- a/lnet/selftest/timer.c
+++ b/lnet/selftest/timer.c
@@ -191,6 +191,8 @@ stt_timer_main (void *arg)
                                    stt_data.stt_shuttingdown,
                                    cfs_time_seconds(STTIMER_SLOTTIME),
                                    rc);
+                if (rc != -ETIMEDOUT)
+                        CDEBUG(D_INFO, "wait return %d\n", rc);
         }
 
         cfs_spin_lock(&stt_data.stt_lock);
